use flume::{Receiver, Sender};
use std::io::Write;
use std::net::UdpSocket;
use std::thread::{self, JoinHandle};
use std::time::{Duration, Instant};

fn listen() -> (JoinHandle<()>, Sender<Vec<u8>>, Receiver<Vec<u8>>) {
    let (tx, rx) = flume::unbounded();

    let tx_clone = tx.clone();
    let rx_clone = rx.clone();

    (
        thread::spawn(move || {
            let socket = UdpSocket::bind("127.0.0.1:13337").unwrap();

            dbg!(&socket);

            loop {
                let mut buf = [0; 256];
                //println!("[udp_socket] waiting for msg");
                let (len, src) = socket.recv_from(&mut buf).unwrap();

                let buf = &mut buf[..len];
                tx.send(Vec::from(buf)).unwrap();
            }
        }),
        tx_clone,
        rx_clone,
    )
}

fn print_hex(bytes: &[u8]) {
    let stdout = std::io::stdout();
    let mut stdout = stdout.lock();

    let mut hxp = hexyl::Printer::new(&mut stdout, true, hexyl::BorderStyle::None, false);
    let _ = hxp.print_all(bytes);
}

fn main() {
    let (thread_udp, thread_udp_tx, thread_udp_rx) = listen();

    for msg in thread_udp_rx.iter() {
        print_hex(&msg);
    }

    let _ = thread_udp.join();
}
